#include <tiny13.h>
#include <delay.h>
#include <m8_128.h>

#define A PORTB.3
#define B PORTB.4
#define C PORTB.0
#define D PORTB.1
#define E PORTB.2

                                      
u8 counter,a,b,c,d,e,bri=250,rep;
u8 ba,bb,bc,bd,be;



start()
{
while(a<100){a++;b++;c++;d++;e++;delay_ms(80);}
}




cycle()
{    
a=0;b=0;c=0;d=0;e=0;
while(a<bri){a++;e++;delay_ms(1);}
while(b<bri){b++;d++;delay_ms(1);}
while(c<bri){c++;delay_ms(1);}
delay_ms(100);
a=0;b=0;c=0;d=0;e=0;
delay_ms(100);
}






pereliv()
{
while(a<bri) {a++; delay_us(100);}
while(e>0) {e--; delay_us(100);}
while(b<bri) {b++; delay_us(100);}
while(a>0) {a--; delay_us(100);}
while(c<bri) {c++; delay_us(100);}
while(b>0) {b--; delay_us(100);}
while(d<bri) {d++; delay_us(100);} 
while(c>0) {c--; delay_us(100);} 
while(e<bri) {e++; delay_us(100);}
while(d>0) {d--; delay_us(100);}  
} 
 
 

half_heartbits ()
{
a=0;b=0;c=0;d=0;e=0;
      

      
while(a<bri){a++;delay_us(200);}  
while(a>0){a--;delay_us(200);}
while(e<bri){e++;delay_us(200);} 
while(e>0){e--;delay_us(200);}      

while(b<bri){b++;delay_us(200);}  
while(b>0){b--;delay_us(200);}
while(d<bri){d++;delay_us(200);} 
while(d>0){d--;delay_us(200);}  

while(c<bri){c++;delay_us(200);}  
while(c>0){c--;delay_us(200);}

      
}





heartbits ()
{
a=100;b=100;c=100;d=100;e=100;
      
delay_ms(500);
      
while(a<bri){a++;b++;c++;d++;e++;delay_us(300);}
      
delay_ms(150);
      
a=100;b=100;c=100;d=100;e=100;
      
delay_ms(150);

while(a<bri){a++;b++;c++;d++;e++;delay_us(130);}
      
delay_ms(150);
}


interrupt [TIM0_OVF] void timer0_ovf_isr(void)
{
counter++;
if(counter==0) {ba=a;bb=b;bd=d;bc=c;be=e; A=1;B=1;C=1;D=1;E=1;}
if(ba==counter) A=0;
if(bb==counter) B=0;
if(bc==counter) C=0;
if(bd==counter) D=0;
if(be==counter) E=0;

}


void main(void)
{

PORTB=0x00;
DDRB=0x1F;


TCCR0A=0x00;
TCCR0B=0x01;
TCNT0=0x00;
OCR0A=0x00;
OCR0B=0x00;


GIMSK=0x00;
MCUCR=0x00;

TIMSK0=0x02;

#asm("sei")
start();
while (1)
      {
       
      for(rep=0;rep<10;rep++)heartbits ();
      for(rep=0;rep<15;rep++)cycle();
      for(rep=0;rep<15;rep++)half_heartbits ();
      for(rep=0;rep<15;rep++)pereliv(); 
         

      };
}
